## xz-utils 5.4.1

=== debian/changelog ===
xz-utils (5.4.1-1) bookworm-security; urgency=medium

  * Add fix from upstream when the threaded decompresses frees memory too
    early on invalid input (CVE-2025-31115).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Thu, 03 Apr 2025 21:55:39 +0200

xz-utils (5.4.1-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Increase replaces/breaks relationship with manpages-{de|fr}
    (Closes: #1028375).
  * Add da.po translation translation from manpages-l10n (Closes: #1029349).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Sun, 12 Feb 2023 21:22:50 +0100

xz-utils (5.4.1-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Update pt_BR translations.
  * Add lintian overrides and an override for blhc.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Wed, 01 Feb 2023 17:41:36 +0100

xz-utils (5.4.1-0.0) unstable; urgency=medium

  * Non-maintainer upload.
  * Import 5.4.1.
  * Provide proper package relationship with manpages-{de|fr}
   (Closes: #1028375).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Wed, 11 Jan 2023 23:00:00 +0100

xz-utils (5.4.0-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Upload to unstable.
  * Add RRR = no to control file.
  * Point VCS tags to salsa.d.o.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Thu, 15 Dec 2022 18:14:49 +0100

xz-utils (5.4.0-0.0) experimental; urgency=medium

  * Non-maintainer upload.
  * Import 5.4.0.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Tue, 13 Dec 2022 23:49:25 +0100

xz-utils (5.3.5beta-0.0) experimental; urgency=medium

  * Non-maintainer upload.
  * Import 5.3.5beta.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Fri, 02 Dec 2022 22:10:13 +0100

xz-utils (5.3.4alpha-0.0) experimental; urgency=medium

  * Non-maintainer upload.
  * Import 5.3.4alpha.
  * Update upstream's GPG key.
  * Update standards to 4.6.1.
  * Add hardening=+all.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Fri, 18 Nov 2022 23:25:47 +0100

xz-utils (5.3.3alpha-0.0) experimental; urgency=medium

  * Non-maintainer upload.
  * Import 5.3.3alpha.
  * Add new symbols.
  * Upgrade to dh compat 13
    - Drop additional rules/ targets for the three flavours and use one.
    - Add indep targets to skip most of the build process for the indep only
      build.
    - Use autoreconf from dh
    - Update paths for installation and record not used files in not-installed
    - Update path in the docs package since newer dh detects liblzma-dev as
      the main package.
  * Provide de/fr man page (Closes: #988580, #995982).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Sun, 02 Oct 2022 22:04:04 +0200

=== debian/control ===
Source: xz-utils
Section: utils
Priority: optional
Maintainer: Sebastian Andrzej Siewior <sebastian@breakpoint.cc>
Uploaders: Jonathan Nieder <jrnieder@gmail.com>
Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.2),
 autoconf (>= 2.64~), automake, libtool (>= 2.2),
 gettext, autopoint | gettext (<< 0.18-1), autopoint | cvs, po4a
Build-Depends-Indep: doxygen
Build-Conflicts: automake1.4
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/debian/xz-utils
Vcs-Git: https://salsa.debian.org/debian/xz-utils
Homepage: https://tukaani.org/xz/
Rules-Requires-Root: no

Package: liblzma5
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Breaks: liblzma2 (<< 5.1.1alpha+20110809-3~)
Multi-Arch: same
Description: XZ-format compression library
 XZ is the successor to the Lempel-Ziv/Markov-chain Algorithm
 compression format, which provides memory-hungry but powerful
 compression (often better than bzip2) and fast, easy decompression.
 .
 The native format of liblzma is XZ; it also supports raw (headerless)
 streams and the older LZMA format used by lzma. (For 7-Zip's related
 format, use the p7zip package instead.)

Package: xz-utils
Priority: standard
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: foreign
Conflicts: lzma (<< 9.22-1), xz-lzma
Breaks: lzip (<< 1.8~rc2), manpages-de (<< 4.17.0-2~bpo11+1), manpages-fr (<< 4.17.0-2~bpo11+1)
Replaces: lzip (<< 1.8~rc2), xz-lzma, manpages-de (<< 4.17.0-2~bpo11+1), manpages-fr (<< 4.17.0-2~bpo11+1)
Provides: lzma
Description: XZ-format compression utilities
 XZ is the successor to the Lempel-Ziv/Markov-chain Algorithm
 compression format, which provides memory-hungry but powerful
 compression (often better than bzip2) and fast, easy decompression.
 .
 This package provides the command line tools for working with XZ
 compression, including xz, unxz, xzcat, xzgrep, and so on. They can
 also handle the older LZMA format, and if invoked via appropriate
 symlinks will emulate the behavior of the commands in the lzma
 package.
 .
 The XZ format is similar to the older LZMA format but includes some
 improvements for general use:
 .
  * 'file' magic for detecting XZ files;
  * crc64 data integrity check;
  * limited random-access reading support;
  * improved support for multithreading (not used in xz-utils);
  * support for flushing the encoder.

Package: xzdec
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: foreign
Suggests: xz-utils
Breaks: xz-lzma (<< 4.999.9beta+20091004-1)
Replaces: xz-lzma (<< 4.999.9beta+20091004-1)
Description: XZ-format compression utilities - tiny decompressors
 XZ is the successor to the Lempel-Ziv/Markov-chain Algorithm
 compression format, which provides memory-hungry but powerful
 compression (often better than bzip2) and fast, easy decompression.
 .
 This package provides the xzdec and lzmadec utilities, which write
 the decompressed version of a compressed file to standard output. The
 binaries are very small, so they can be easily stored on small media
 with some compressed files, and they are linked statically against
 liblzma so they can be used on machines without a compatible version
 of liblzma installed. However, they have:
 .
   * no compression support;
   * no support for writing to a file other than standard output;
   * no translated messages;
   * been optimized for size rather than speed.
 .
 For a full-featured xzcat command without these limitations, use
 the xz-utils package instead.

Package: liblzma-dev
Section: libdevel
Multi-Arch: same
Architecture: any
Depends: liblzma5 (= ${binary:Version}), ${misc:Depends}
Suggests: liblzma-doc
Description: XZ-format compression library - development files
 XZ is the successor to the Lempel-Ziv/Markov-chain Algorithm
 compression format, which provides memory-hungry but powerful
 compression (often better than bzip2) and fast, easy decompression.
 .
 The native format of liblzma is XZ; it also supports raw (headerless)
 streams and the older LZMA format used by lzma. (For 7-Zip's related
 format, use the p7zip package instead.) This package provides the
 development library needed to build programs using liblzma.

Package: liblzma-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: liblzma-dev
Description: XZ-format compression library - API documentation
 This package contains a reference manual for the liblzma data
 compression library, in Doxygen-generated HTML files. The purpose
 of each struct, macro, and function in the public interface is
 explained.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ $(opt_no_act)

override_dh_autoreconf:
	./autogen.sh

override_dh_auto_clean:
	dh_auto_clean --builddirectory debian/xzdec-build
	dh_auto_clean --builddirectory debian/normal-build
	dh_auto_clean --builddirectory debian/static-build

override_dh_auto_install-indep:

override_dh_auto_install-arch:
	dh_auto_install --builddirectory debian/xzdec-build
	dh_auto_install --builddirectory debian/normal-build
	dh_auto_install --builddirectory debian/static-build
	set -e; arch=$$(dpkg-architecture -qDEB_HOST_MULTIARCH); \
	install -d debian/tmp/lib/$$arch; \
	mv debian/tmp/usr/lib/$$arch/liblzma.so.* debian/tmp/lib/$$arch/; \
	dso=$$(basename $$(readlink debian/tmp/usr/lib/$$arch/liblzma.so)); \
	ln -s -f /lib/$$arch/$$dso debian/tmp/usr/lib/$$arch/liblzma.so

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_auto_build-indep:
	cd debian/normal-build && doxygen Doxyfile

override_dh_auto_build-arch:
	$(MAKE) -C debian/normal-build/po update-gmo
	dh_auto_build --builddirectory debian/normal-build
	dh_auto_build --builddirectory debian/static-build
	# The xzdec binary/ package is built with -Os as suggested in PACKAGERS
	# to create a small binary.
	@echo "blhc: ignore-line-regexp: .*-D_BLHC_IGNORE_THIS_LINE.*"
	dh_auto_build --builddirectory debian/xzdec-build

override_dh_auto_test-indep:

override_dh_auto_test-arch:
ifneq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	@echo Skipping tests
else
	dh_auto_test --builddirectory debian/normal-build
	dh_auto_test --builddirectory debian/static-build
	dh_auto_test --builddirectory debian/xzdec-build
endif

override_dh_auto_configure:
	dh_auto_configure --builddirectory debian/normal-build -- \
		$(opt_reproduce) \
		--enable-threads --disable-static \
		$(opt_optimize) $(opt_quiet) \
		--disable-xzdec --disable-lzmadec
	dh_auto_configure --builddirectory debian/static-build -- \
		$(opt_reproduce) \
		--enable-threads --disable-shared \
		--enable-liblzma2-compat \
		$(opt_optimize) $(opt_quiet) \
		--disable-lzmainfo --disable-scripts \
		--disable-xzdec --disable-lzmadec \
		--disable-xz --disable-lzma-links
	dh_auto_configure --builddirectory debian/xzdec-build -- \
		$(opt_reproduce) \
		--disable-shared --disable-nls --disable-encoders \
		--enable-small --disable-threads \
		--disable-liblzma2-compat \
		$(opt_optimize_small) $(opt_quiet) \
		--disable-lzmainfo --disable-scripts \
		--disable-xz --disable-lzma-links

small_flags_env =
small_flags_env += DEB_CFLAGS_MAINT_STRIP='-O2 -O3'
small_flags_env += DEB_CFLAGS_MAINT_PREPEND=-Os -D_BLHC_IGNORE_THIS_LINE
flags_cmd = dpkg-buildflags --export=configure
opt_optimize = $(shell $(flags_cmd))
opt_optimize_small = $(shell $(small_flags_env) $(flags_cmd))
opt_reproduce = gl_cv_posix_shell=/bin/sh

opt_no_act =
opt_quiet =

# Unless noopt is set, use optimized CRC32 routine on the Hurd.
ifeq (hurd,$(shell dpkg-architecture -qDEB_HOST_ARCH_OS))
    cputype := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
    ifeq (i386,$(cputype))
        opt_optimize += --enable-assembler=x86
        opt_optimize_small += --enable-assembler=x86
    endif
    ifeq (amd64,$(cputype))
        opt_optimize += --enable-assembler=x86_64
        opt_optimize_small += --enable-assembler=x86_64
    endif
endif

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
    opt_optimize += --disable-assembler
    opt_optimize_small += --disable-assembler
endif

ifneq (,$(findstring n,$(MAKEFLAGS)))
    opt_no_act = --no-act
endif

ifneq (,$(filter quiet,$(DEB_BUILD_OPTIONS)))
    opt_quiet = --quiet
    MAKEFLAGS += --quiet
endif

# Build a tarball with the latest upstream version.
# This is made complicated by the need to choose a nice version number.
REPO = https://git.tukaani.org/xz.git
BRANCH = master
get-orig-source:
	mkdir debian-orig-source
	-set -e; cd debian-orig-source; \
	: Fetch latest upstream version.; \
		git init -q; \
		git fetch -q --tags $(REPO); \
		git fetch -q $(REPO) $(BRANCH); \
	: Determine version number.; \
		commit_name=$$(git describe FETCH_HEAD); \
		release=$${commit_name%%-*}; \
		date=$$(date --utc --date="$$( \
			git log -1 --pretty=format:%cD "$$commit_name" \
			)" "+%Y%m%d"); \
		if test "$$commit_name" = "$$release"; \
		then upstream_version=$${commit_name#v}; \
		else upstream_version="$${release#v}+$${date}"; \
		fi; \
	: Generate tarball.; \
		echo "packaging $$commit_name"; \
		git archive --format=tar "$$commit_name" \
			--prefix="xz-utils-$$upstream_version/" | \
		gzip -n --rsyncable -9 \
			> "../xz-utils_$$upstream_version.orig.tar.gz"
	rm -fr debian-orig-source

=== debian/tests/control ===
Tests: testsuite
Depends: debhelper-compat (= 13), autoconf (>= 2.64~), automake, libtool (>= 2.2), gettext, @
Restrictions: rw-build-tree

=== debian/watch ===
version=4
opts=dversionmangle=s/\+\d{8}$//,pgpsigurlmangle=s/$/.sig/ \
https://tukaani.org/xz/xz-([\d.]*(?:beta)?)\.tar\.xz

## xz-utils 5.4.5

=== debian/changelog ===
xz-utils (5.4.5-0.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Source-only upload for testing eligibility.

 -- Cyril Brulebois <kibi@debian.org>  Sat, 23 Dec 2023 20:05:15 +0100

xz-utils (5.4.5-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Add liblzma5-udeb, needed for kmod to gain support for compressed
    modules.

 -- Cyril Brulebois <kibi@debian.org>  Sat, 23 Dec 2023 19:05:39 +0100

xz-utils (5.4.5-0.1) unstable; urgency=medium

  [ Sebastian Andrzej Siewior ]
  * Non-maintainer upload.
  * Import 5.4.5.

  [ Helmut Grohne ]
  * Move liblzma.so.* to /usr. (Closes: #1055942).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Thu, 23 Nov 2023 20:54:59 +0100

xz-utils (5.4.4-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Import 5.4.4.
  * Don't redo translation, the patches are in the upstream release
    (Closes: #1047952).
  * Don't crc32 assembly on hurd-amd64. Patch by Samuel Thibault
    (Closes: #1035615).
  * Update doxygen generation for public API.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Wed, 30 Aug 2023 20:38:53 +0200

=== debian/rules ===
--- 
+++ 
@@ -4,10 +4,8 @@
 %:
 	dh $@ $(opt_no_act)
 
-override_dh_autoreconf:
-	./autogen.sh
-
 override_dh_auto_clean:
+	if [ -f doc/api.backup.done ]; then rm -rf doc/api; mv doc/api.backup doc/api; rm doc/api.backup.done; else rm -rf doc/api.backup*; fi
 	dh_auto_clean --builddirectory debian/xzdec-build
 	dh_auto_clean --builddirectory debian/normal-build
 	dh_auto_clean --builddirectory debian/static-build
@@ -18,20 +16,15 @@
 	dh_auto_install --builddirectory debian/xzdec-build
 	dh_auto_install --builddirectory debian/normal-build
 	dh_auto_install --builddirectory debian/static-build
-	set -e; arch=$$(dpkg-architecture -qDEB_HOST_MULTIARCH); \
-	install -d debian/tmp/lib/$$arch; \
-	mv debian/tmp/usr/lib/$$arch/liblzma.so.* debian/tmp/lib/$$arch/; \
-	dso=$$(basename $$(readlink debian/tmp/usr/lib/$$arch/liblzma.so)); \
-	ln -s -f /lib/$$arch/$$dso debian/tmp/usr/lib/$$arch/liblzma.so
 
 override_dh_installchangelogs:
 	dh_installchangelogs ChangeLog
 
 override_dh_auto_build-indep:
-	cd debian/normal-build && doxygen Doxyfile
+	if [ ! -d doc/api.backup ]; then cp --reflink=auto -ra doc/api doc/api.backup; touch doc/api.backup.done; fi
+	cd doxygen && sh update-doxygen
 
 override_dh_auto_build-arch:
-	$(MAKE) -C debian/normal-build/po update-gmo
 	dh_auto_build --builddirectory debian/normal-build
 	dh_auto_build --builddirectory debian/static-build
 	# The xzdec binary/ package is built with -Os as suggested in PACKAGERS
@@ -75,7 +68,7 @@
 
 small_flags_env =
 small_flags_env += DEB_CFLAGS_MAINT_STRIP='-O2 -O3'
-small_flags_env += DEB_CFLAGS_MAINT_PREPEND=-Os -D_BLHC_IGNORE_THIS_LINE
+small_flags_env += DEB_CFLAGS_MAINT_PREPEND='-Os -D_BLHC_IGNORE_THIS_LINE'
 flags_cmd = dpkg-buildflags --export=configure
 opt_optimize = $(shell $(flags_cmd))
 opt_optimize_small = $(shell $(small_flags_env) $(flags_cmd))
@@ -90,10 +83,6 @@
     ifeq (i386,$(cputype))
         opt_optimize += --enable-assembler=x86
         opt_optimize_small += --enable-assembler=x86
-    endif
-    ifeq (amd64,$(cputype))
-        opt_optimize += --enable-assembler=x86_64
-        opt_optimize_small += --enable-assembler=x86_64
     endif
 endif
 
@@ -110,6 +99,9 @@
     opt_quiet = --quiet
     MAKEFLAGS += --quiet
 endif
+
+override_dh_makeshlibs:
+	dh_makeshlibs --add-udeb=liblzma5-udeb
 
 # Build a tarball with the latest upstream version.
 # This is made complicated by the need to choose a nice version number.

## xz-utils 5.6.1+really5.4.5

=== CMakeLists.txt ===
#############################################################################
#
# Very limited CMake support for building some parts of XZ Utils
#
# For now, this is intended to be useful to build static or shared liblzma
# on Windows with MSVC (to avoid the need to maintain Visual Studio project
# files). Building liblzma on a few other platforms should work too but it
# is somewhat experimental and not as portable as using ./configure.
#
# On some platforms this builds also xz and xzdec, but these are
# highly experimental and meant for testing only:
#   - No replacement getopt_long(), libc must have it
#   - No sandboxing support
#   - No translations
#
# Other missing things:
#   - No xzgrep or other scripts or their symlinks
#   - No xz tests (liblzma tests only)
#
# NOTE: Even if the code compiles without warnings, the end result may be
# different than via ./configure. Specifically, the list of #defines
# may be different (if so, probably this CMakeLists.txt got them wrong).
#
# This file provides the following installation components (if you only
# need liblzma, install only its components!):
#   - liblzma_Runtime
#   - liblzma_Development
#   - xz (on some platforms only)
#   - xzdec (on some platforms only)
#
# To find the target liblzma::liblzma from other packages, use the CONFIG
# option with find_package() to avoid a conflict with the FindLibLZMA module
# with case-insensitive file systems. For example, to require liblzma 5.2.5
# or a newer compatible version:
#
#     find_package(liblzma 5.2.5 REQUIRED CONFIG)
#     target_link_libraries(my_application liblzma::liblzma)
#
#############################################################################
#
# Author: Lasse Collin
#
# This file has been put into the public domain.
# You can do whatever you want with this file.
#
#############################################################################

cmake_minimum_required(VERSION 3.13...3.27 FATAL_ERROR)

include(CMakePushCheckState)
include(CheckIncludeFile)
include(CheckSymbolExists)
include(CheckStructHasMember)
include(CheckCSourceCompiles)
include(cmake/tuklib_large_file_support.cmake)
include(cmake/tuklib_integer.cmake)
include(cmake/tuklib_cpucores.cmake)
include(cmake/tuklib_physmem.cmake)
include(cmake/tuklib_progname.cmake)
include(cmake/tuklib_mbstr.cmake)

set(PACKAGE_NAME "XZ Utils")
set(PACKAGE_BUGREPORT "xz@tukaani.org")
set(PACKAGE_URL "https://tukaani.org/xz/")

# Get the package version from version.h into PACKAGE_VERSION variable.
file(READ src/liblzma/api/lzma/version.h PACKAGE_VERSION)
string(REGEX REPLACE
"^.*\n\
#define LZMA_VERSION_MAJOR ([0-9]+)\n\
.*\
#define LZMA_VERSION_MINOR ([0-9]+)\n\
.*\
#define LZMA_VERSION_PATCH ([0-9]+)\n\
.*$"
       "\\1.\\2.\\3" PACKAGE_VERSION "${PACKAGE_VERSION}")

# Among other things, this gives us variables xz_VERSION and xz_VERSION_MAJOR.
project(xz VERSION "${PACKAGE_VERSION}" LANGUAGES C)

# We need a compiler that supports enough C99 or newer (variable-length arrays
# aren't needed, those are optional in C17). Setting CMAKE_C_STANDARD here
# makes it the default for all targets. It doesn't affect the INTERFACE so
# liblzma::liblzma won't end up with INTERFACE_COMPILE_FEATURES "c_std_99"
# (the API headers are C89 and C++ compatible).
set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED ON)

# On Apple OSes, don't build executables as bundles:
set(CMAKE_MACOSX_BUNDLE OFF)

# windres from GNU binutils can be tricky with command line arguments
# that contain spaces or other funny characters. Unfortunately we need
# a space in PACKAGE_NAME. Using \x20 to encode the US-ASCII space seems
# to work in both cmd.exe and /bin/sh.
#
# However, even \x20 isn't enough in all situations, resulting in
# "syntax error" from windres. Using --use-temp-file prevents windres
# from using popen() and this seems to fix the problem.
#
# llvm-windres from Clang/LLVM 16.0.6 and older: The \x20 results
# in "XZx20Utils" in the compiled binary. The option --use-temp-file
# makes no difference.
#
# llvm-windres 17.0.0 and later: It emulates GNU windres more accurately, so
# the workarounds used with GNU windres must be used with llvm-windres too.
#
# CMake 3.27 doesn't have CMAKE_RC_COMPILER_ID so we rely on
# CMAKE_C_COMPILER_ID.
if((MINGW OR CYGWIN OR MSYS) AND (
        NOT CMAKE_C_COMPILER_ID STREQUAL "Clang" OR
        CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL "17"))
    # Use workarounds with GNU windres and llvm-windres >= 17.0.0. The \x20
    # in PACKAGE_NAME_DEFINITION works with gcc and clang too so we don't need
    # to worry how to pass different flags to windres and the C compiler.
    # Keep the original PACKAGE_NAME intact for generation of liblzma.pc.
    string(APPEND CMAKE_RC_FLAGS " --use-temp-file")
    string(REPLACE " " "\\x20" PACKAGE_NAME_DEFINITION "${PACKAGE_NAME}")
else()
    # Elsewhere a space is safe. This also keeps things compatible with
    # EBCDIC in case CMake-based build is ever done on such a system.
    set(PACKAGE_NAME_DEFINITION "${PACKAGE_NAME}")
endif()

# Definitions common to all targets:
add_compile_definitions(
    # Package info:
    PACKAGE_NAME="${PACKAGE_NAME_DEFINITION}"
    PACKAGE_BUGREPORT="${PACKAGE_BUGREPORT}"
    PACKAGE_URL="${PACKAGE_URL}"

    # Standard headers and types are available:
    HAVE_STDBOOL_H
    HAVE__BOOL
    HAVE_STDINT_H
    HAVE_INTTYPES_H

    # Always enable CRC32 since liblzma should never build without it.
    HAVE_CHECK_CRC32

    # Disable assert() checks when no build type has been specified. Non-empty
    # build types like "Release" and "Debug" handle this by default.
    $<$<CONFIG:>:NDEBUG>
)


######################
# System definitions #
######################

# _GNU_SOURCE and such definitions. This specific macro is special since
# it also adds the definitions to CMAKE_REQUIRED_DEFINITIONS.
tuklib_use_system_extensions(ALL)

# Check for large file support. It's required on some 32-bit platforms and
# even on 64-bit MinGW-w64 to get 64-bit off_t. This can be forced off on
# the CMake command line if needed: -DLARGE_FILE_SUPPORT=OFF
tuklib_large_file_support(ALL)

# This is needed by liblzma and xz.
tuklib_integer(ALL)

# This is used for liblzma.pc generation to add -lrt if needed.
set(LIBS)

# Check for clock_gettime(). Do this before checking for threading so
# that we know there if CLOCK_MONOTONIC is available.
if(NOT WIN32)
    check_symbol_exists(clock_gettime time.h HAVE_CLOCK_GETTIME)

    if(NOT HAVE_CLOCK_GETTIME)
        # With glibc <= 2.17 or Solaris 10 this needs librt.
        # Add librt for the next check for HAVE_CLOCK_GETTIME. If it is
        # found after including the library, we know that librt is required.
        list(INSERT CMAKE_REQUIRED_LIBRARIES 0 rt)
        check_symbol_exists(clock_gettime time.h HAVE_CLOCK_GETTIME_LIBRT)

        # If it was found now, add librt to all targets and keep it in
        # CMAKE_REQUIRED_LIBRARIES for further tests too.
        if(HAVE_CLOCK_GETTIME_LIBRT)
            link_libraries(rt)
            set(LIBS "-lrt") # For liblzma.pc
        else()
            list(REMOVE_AT CMAKE_REQUIRED_LIBRARIES 0)
        endif()
    endif()

    if(HAVE_CLOCK_GETTIME OR HAVE_CLOCK_GETTIME_LIBRT)
        add_compile_definitions(HAVE_CLOCK_GETTIME)

        # Check if CLOCK_MONOTONIC is available for clock_gettime().
        check_symbol_exists(CLOCK_MONOTONIC time.h HAVE_CLOCK_MONOTONIC)
        tuklib_add_definition_if(ALL HAVE_CLOCK_MONOTONIC)
    endif()
endif()

# Options for new enough GCC or Clang on any arch or operating system:
if(CMAKE_C_COMPILER_ID MATCHES GNU|Clang)
    # configure.ac has a long list but it won't be copied here:
    add_compile_options(-Wall -Wextra)
endif()


#############################################################################
# liblzma
#############################################################################

option(BUILD_SHARED_LIBS "Build liblzma as a shared library instead of static")

add_library(liblzma
    src/common/mythread.h
    src/common/sysdefs.h
    src/common/tuklib_common.h
    src/common/tuklib_config.h
    src/common/tuklib_integer.h
    src/common/tuklib_physmem.c
    src/common/tuklib_physmem.h
    src/liblzma/api/lzma.h
    src/liblzma/api/lzma/base.h
    src/liblzma/api/lzma/bcj.h
    src/liblzma/api/lzma/block.h
    src/liblzma/api/lzma/check.h
    src/liblzma/api/lzma/container.h
    src/liblzma/api/lzma/delta.h
    src/liblzma/api/lzma/filter.h
    src/liblzma/api/lzma/hardware.h
    src/liblzma/api/lzma/index.h
    src/liblzma/api/lzma/index_hash.h
    src/liblzma/api/lzma/lzma12.h
    src/liblzma/api/lzma/stream_flags.h
    src/liblzma/api/lzma/version.h
    src/liblzma/api/lzma/vli.h
    src/liblzma/check/check.c
    src/liblzma/check/check.h
    src/liblzma/check/crc_macros.h
    src/liblzma/common/block_util.c
    src/liblzma/common/common.c
    src/liblzma/common/common.h
    src/liblzma/common/easy_preset.c
    src/liblzma/common/easy_preset.h
    src/liblzma/common/filter_common.c
    src/liblzma/common/filter_common.h
    src/liblzma/common/hardware_physmem.c
    src/liblzma/common/index.c
    src/liblzma/common/index.h
    src/liblzma/common/memcmplen.h
    src/liblzma/common/stream_flags_common.c
    src/liblzma/common/stream_flags_common.h
    src/liblzma/common/string_conversion.c
    src/liblzma/common/vli_size.c
)

target_include_directories(liblzma PRIVATE
    src/liblzma/api
    src/liblzma/common
    src/liblzma/check
    src/liblzma/lz
    src/liblzma/rangecoder
    src/liblzma/lzma
    src/liblzma/delta
    src/liblzma/simple
    src/common
)


######################
# Size optimizations #
######################

option(ENABLE_SMALL "Reduce code size at expense of speed. \
This may be useful together with CMAKE_BUILD_TYPE=MinSizeRel.")

if(ENABLE_SMALL)
    add_compile_definitions(HAVE_SMALL)
endif()


##########
# Checks #
##########

set(ADDITIONAL_SUPPORTED_CHECKS crc64 sha256)

set(ADDITIONAL_CHECK_TYPES "${ADDITIONAL_SUPPORTED_CHECKS}" CACHE STRING
    "Additional check types to support (crc32 is always built)")

foreach(CHECK IN LISTS ADDITIONAL_CHECK_TYPES)
    if(NOT CHECK IN_LIST ADDITIONAL_SUPPORTED_CHECKS)
        message(FATAL_ERROR "'${CHECK}' is not a supported check type")
    endif()
endforeach()

if(ENABLE_SMALL)
    target_sources(liblzma PRIVATE src/liblzma/check/crc32_small.c)
else()
    target_sources(liblzma PRIVATE
        src/liblzma/check/crc32_fast.c
        src/liblzma/check/crc32_table.c
        src/liblzma/check/crc32_table_be.h
        src/liblzma/check/crc32_table_le.h
    )
endif()

if("crc64" IN_LIST ADDITIONAL_CHECK_TYPES)
    add_compile_definitions("HAVE_CHECK_CRC64")

    if(ENABLE_SMALL)
        target_sources(liblzma PRIVATE src/liblzma/check/crc64_small.c)
    else()
        target_sources(liblzma PRIVATE
            src/liblzma/check/crc64_fast.c
            src/liblzma/check/crc64_table.c
            src/liblzma/check/crc64_table_be.h
            src/liblzma/check/crc64_table_le.h
        )
    endif()
endif()

if("sha256" IN_LIST ADDITIONAL_CHECK_TYPES)
    add_compile_definitions("HAVE_CHECK_SHA256")
    target_sources(liblzma PRIVATE src/liblzma/check/sha256.c)
endif()


#################
# Match finders #
#################

set(SUPPORTED_MATCH_FINDERS hc3 hc4 bt2 bt3 bt4)

set(MATCH_FINDERS "${SUPPORTED_MATCH_FINDERS}" CACHE STRING
    "Match finders to support (at least one is required for LZMA1 or LZMA2)")

foreach(MF IN LISTS MATCH_FINDERS)
    if(MF IN_LIST SUPPORTED_MATCH_FINDERS)
        string(TOUPPER "${MF}" MF_UPPER)
        add_compile_definitions("HAVE_MF_${MF_UPPER}")
    else()
        message(FATAL_ERROR "'${MF}' is not a supported match finder")
    endif()
endforeach()


#############
# Threading #
#############

# Supported threading methods:
# ON    - autodetect the best threading method. The autodetection will
#         prefer Windows threading (win95 or vista) over posix if both are

=== debian/changelog ===
xz-utils (5.6.1+really5.4.5-1ubuntu0.2) noble-security; urgency=medium

  * SECURITY UPDATE: issue in threaded .xz decoder
    - debian/patches/CVE-2025-31115-1.patch: fix a comment in
      src/liblzma/common/stream_decoder_mt.c.
    - debian/patches/CVE-2025-31115-2.patch: simplify by removing the
      THR_STOP state in src/liblzma/common/stream_decoder_mt.c.
    - debian/patches/CVE-2025-31115-3.patch: don't free the input buffer
      too early in src/liblzma/common/stream_decoder_mt.c.
    - debian/patches/CVE-2025-31115-4.patch: don't modify thr->in_size in
      the worker thread in src/liblzma/common/stream_decoder_mt.c.
    - CVE-2025-31115

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 31 Mar 2025 14:22:22 -0400

xz-utils (5.6.1+really5.4.5-1build0.1) noble-proposed; urgency=medium

  * SRU: LP: #2076340: No-change rebuild to pick up changed build flags
    on ppc64 and s390x.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 09 Aug 2024 04:33:21 +0200

xz-utils (5.6.1+really5.4.5-1) unstable; urgency=critical

  * Non-maintainer upload by the Security Team.
  * Revert back to the 5.4.5-0.2 version 

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 28 Mar 2024 15:59:38 +0100

xz-utils (5.6.1-1) unstable; urgency=medium

  * Non-maintainer upload.
  * Import 5.6.1 (Closes: #1067708).
  * Takeover maintenance of the package.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Wed, 27 Mar 2024 22:53:21 +0100

xz-utils (5.6.0-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Move xz's output of reduced threads to debug output.
  * Add missing RISC-V on the filter list in the man page.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Wed, 28 Feb 2024 20:03:45 +0100

xz-utils (5.6.0-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Import 5.6.0
  * Add Breaks on pristine-tar because of the different default behaviour
    regarding the -T argument.
  * Upload to unstable.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Mon, 26 Feb 2024 07:47:01 +0100

xz-utils (5.5.2beta-1) experimental; urgency=medium

  * Non-maintainer upload.
  * Import 5.5.2beta
  * Mark liblzma-doc multi-arch foreign.
  * Update copyright file, most files are now under 0BSD.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Thu, 15 Feb 2024 21:42:23 +0100

xz-utils (5.5.1alpha-0.1) experimental; urgency=medium

  * Non-maintainer upload.
  * Import 5.5.1alpha.
  * Add new symbol.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Wed, 31 Jan 2024 21:44:23 +0100

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,17 @@
 Source: xz-utils
 Section: utils
 Priority: optional
-Maintainer: Sebastian Andrzej Siewior <sebastian@breakpoint.cc>
-Uploaders: Jonathan Nieder <jrnieder@gmail.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Jonathan Nieder <jrnieder@gmail.com>
+Uploaders: Mohammed Adnène Trojette <adn+deb@diwi.org>
 Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.2),
  autoconf (>= 2.64~), automake, libtool (>= 2.2),
  gettext, autopoint | gettext (<< 0.18-1), autopoint | cvs, po4a
 Build-Depends-Indep: doxygen
 Build-Conflicts: automake1.4
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian/xz-utils
-Vcs-Git: https://salsa.debian.org/debian/xz-utils
+Vcs-Git: https://salsa.debian.org/debian/xz-utils.git
 Homepage: https://tukaani.org/xz/
 Rules-Requires-Root: no
 
@@ -29,6 +30,14 @@
  The native format of liblzma is XZ; it also supports raw (headerless)
  streams and the older LZMA format used by lzma. (For 7-Zip's related
  format, use the p7zip package instead.)
+
+Package: liblzma5-udeb
+Package-Type: udeb
+Section: debian-installer
+Architecture: any
+Depends: ${shlibs:Depends}
+Description: XZ-format compression library
+ This liblzma package is only for use in the installation system.
 
 Package: xz-utils
 Priority: standard

## xz-utils 5.6.1+really5.4.5-1ubuntu0.2trisquel0

=== debian/changelog ===
xz-utils (5.6.1+really5.4.5-1ubuntu0.2trisquel0) ecne-security; urgency=medium

  * Fetch and build as udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Thu, 03 Apr 2025 19:44:15 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: xz-utils
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 XSBC-Original-Maintainer: Jonathan Nieder <jrnieder@gmail.com>
 Uploaders: Mohammed Adnène Trojette <adn+deb@diwi.org>
 Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.2),

## xz-utils 5.6.2

=== debian/changelog ===
xz-utils (5.6.2-2) unstable; urgency=medium

  * Increase symbol dependency on 5.6.0 symbols to 5.6.2 due to the revert.
    Thanks to Ben Hutchings (Closes: #1074602).
  * Correct the `terse' build. Thanks to Ben Hutchings (Closes: #1074604).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Wed, 03 Jul 2024 21:51:43 +0200

xz-utils (5.6.2-1) unstable; urgency=medium

  * Import 5.6.2
  * Takeover maintenance of the package.
  * Revert the debian/ mostly to what was in 5.6.1-1

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Sat, 15 Jun 2024 10:42:31 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: xz-utils
 Section: utils
 Priority: optional
-Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
-XSBC-Original-Maintainer: Jonathan Nieder <jrnieder@gmail.com>
-Uploaders: Mohammed Adnène Trojette <adn+deb@diwi.org>
+Maintainer: Sebastian Andrzej Siewior <sebastian@breakpoint.cc>
+Uploaders: Jonathan Nieder <jrnieder@gmail.com>
 Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.2),
  autoconf (>= 2.64~), automake, libtool (>= 2.2),
  gettext, autopoint | gettext (<< 0.18-1), autopoint | cvs, po4a
-Build-Depends-Indep: doxygen
+Build-Depends-Indep: doxygen, graphviz
 Build-Conflicts: automake1.4
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian/xz-utils
@@ -45,7 +44,7 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Multi-Arch: foreign
 Conflicts: lzma (<< 9.22-1), xz-lzma
-Breaks: lzip (<< 1.8~rc2), manpages-de (<< 4.17.0-2~bpo11+1), manpages-fr (<< 4.17.0-2~bpo11+1)
+Breaks: lzip (<< 1.8~rc2), manpages-de (<< 4.17.0-2~bpo11+1), manpages-fr (<< 4.17.0-2~bpo11+1), pristine-tar (<< 1.50+nmu1)
 Replaces: lzip (<< 1.8~rc2), xz-lzma, manpages-de (<< 4.17.0-2~bpo11+1), manpages-fr (<< 4.17.0-2~bpo11+1)
 Provides: lzma
 Description: XZ-format compression utilities
@@ -113,6 +112,7 @@
 
 Package: liblzma-doc
 Section: doc
+Multi-Arch: foreign
 Architecture: all
 Depends: ${misc:Depends}
 Suggests: liblzma-dev

=== debian/watch ===
version=4
opts=dversionmangle=s/\+\d{8}$//,pgpsigurlmangle=s/$/.sig/ \
https://tukaani.org/xz/		\
https://github.com/tukaani-project/xz/releases/download/v[^/]+/xz-([\d\.]*(?:beta|alpha)?)\.tar\.xz

## xz-utils 5.6.3

=== debian/changelog ===
xz-utils (5.6.3-1) unstable; urgency=medium

  * Import 5.6.3

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Thu, 24 Oct 2024 21:27:12 +0200

## xz-utils 5.6.4

=== tests/ossfuzz/Makefile ===
# SPDX-License-Identifier: 0BSD

FUZZ_TARGET_SRCS = $(wildcard *.c)
FUZZ_TARGET_BINS = $(FUZZ_TARGET_SRCS:.c=)

all: $(FUZZ_TARGET_BINS)

%: %.c
	$(CC) $(CFLAGS) -c $< -I ../../src/liblzma/api/ ;
	$(CXX) $(CXXFLAGS) $(LIB_FUZZING_ENGINE) $(<:.c=.o) -o $(OUT)/$@ \
		../../src/liblzma/.libs/liblzma.a ;

# The generated binaries are not removed, just the object files. The
# binaries are created to the $(OUT) directory and must be removed by the
# fuzzing framework.
clean:
	rm -f *.o

=== debian/changelog ===
xz-utils (5.6.4-1ubuntu1) plucky; urgency=medium

  * SECURITY UPDATE: issue in threaded .xz decoder
    - debian/patches/CVE-2025-31115-1.patch: fix a comment in
      src/liblzma/common/stream_decoder_mt.c.
    - debian/patches/CVE-2025-31115-2.patch: simplify by removing the
      THR_STOP state in src/liblzma/common/stream_decoder_mt.c.
    - debian/patches/CVE-2025-31115-3.patch: don't free the input buffer
      too early in src/liblzma/common/stream_decoder_mt.c.
    - debian/patches/CVE-2025-31115-4.patch: don't modify thr->in_size in
      the worker thread in src/liblzma/common/stream_decoder_mt.c.
    - CVE-2025-31115

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 31 Mar 2025 14:18:04 -0400

xz-utils (5.6.4-1) unstable; urgency=medium

  * Import 5.6.4
  * Sync output file before removing source file (Closes: #814089).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Sat, 01 Mar 2025 21:52:57 +0100

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,15 @@
 Source: xz-utils
 Section: utils
 Priority: optional
-Maintainer: Sebastian Andrzej Siewior <sebastian@breakpoint.cc>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Sebastian Andrzej Siewior <sebastian@breakpoint.cc>
 Uploaders: Jonathan Nieder <jrnieder@gmail.com>
 Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.2),
  autoconf (>= 2.64~), automake, libtool (>= 2.2),
  gettext, autopoint | gettext (<< 0.18-1), autopoint | cvs, po4a
 Build-Depends-Indep: doxygen, graphviz
 Build-Conflicts: automake1.4
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian/xz-utils
 Vcs-Git: https://salsa.debian.org/debian/xz-utils.git
 Homepage: https://tukaani.org/xz/

=== debian/tests/control ===
Tests: testsuite
Depends: debhelper-compat (= 13), autoconf (>= 2.64~), automake, libtool (>= 2.2), gettext, @
Restrictions: rw-build-tree, allow-stderr

=== debian/watch ===
version=4
opts=dversionmangle=s/\+\d{8}$//,pgpsigurlmangle=s/$/.sig/ \
https://tukaani.org/xz/		\
https://github.com/tukaani-project/xz/releases/download/v[^/]+/xz-(5\.6\.[\d\.]*(?:beta|alpha)?)\.tar\.xz

## xz-utils 5.8.0

=== debian/changelog ===
xz-utils (5.8.0-1) experimental; urgency=medium

  * Import 5.8.0

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Wed, 26 Mar 2025 23:01:15 +0100

## xz-utils 5.8.1

=== debian/changelog ===
xz-utils (5.8.1-2) unstable; urgency=medium

  * Skip building docs on "nodoc" instead of "nocheck". Patch by Santiago
    Vila. (Closes: #1103332)
  * Remove the symlinks from -dev, pointing to the lib package.
    (Closes: #1109354)

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Fri, 03 Oct 2025 18:32:16 +0200

xz-utils (5.8.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Sourceful no-change upload for IEEE long double on ppc64el.

 -- Matthias Klose <doko@debian.org>  Thu, 04 Sep 2025 11:21:01 +0200

xz-utils (5.8.1-1) unstable; urgency=medium

  * Import 5.8.1
    - Threaded .xz decoder frees memory too early (CVE-2025-31115)
  * Upload to unstable

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Thu, 03 Apr 2025 23:02:58 +0200

=== debian/rules ===
--- 
+++ 
@@ -5,24 +5,23 @@
 	dh $@ $(opt_no_act)
 
 override_dh_auto_clean:
-	if [ -f doc/api.backup.done ]; then rm -rf doc/api; mv doc/api.backup doc/api; rm doc/api.backup.done; else rm -rf doc/api.backup*; fi
 	dh_auto_clean --builddirectory debian/xzdec-build
 	dh_auto_clean --builddirectory debian/normal-build
 	dh_auto_clean --builddirectory debian/static-build
 
 override_dh_auto_install-indep:
+	dh_auto_install --builddirectory debian/normal-build
 
 override_dh_auto_install-arch:
 	dh_auto_install --builddirectory debian/xzdec-build
+	dh_auto_install --builddirectory debian/static-build
 	dh_auto_install --builddirectory debian/normal-build
-	dh_auto_install --builddirectory debian/static-build
 
 override_dh_installchangelogs:
 	dh_installchangelogs ChangeLog
 
 override_dh_auto_build-indep:
-	if [ ! -d doc/api.backup ]; then cp --reflink=auto -ra doc/api doc/api.backup; touch doc/api.backup.done; fi
-	cd doxygen && sh update-doxygen
+	dh_auto_install --builddirectory debian/normal-build
 
 override_dh_auto_build-arch:
 	dh_auto_build --builddirectory debian/normal-build
@@ -43,7 +42,19 @@
 	dh_auto_test --builddirectory debian/xzdec-build
 endif
 
-override_dh_auto_configure:
+override_dh_auto_configure-indep:
+ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
+	@echo Skipping docs
+else
+	dh_auto_configure --builddirectory debian/normal-build -- \
+		$(opt_reproduce) \
+		--enable-threads --disable-static \
+		$(opt_optimize) $(opt_quiet) 	\
+		--enable-doxygen		\
+		--disable-xzdec --disable-lzmadec
+endif
+
+override_dh_auto_configure-arch:
 	dh_auto_configure --builddirectory debian/normal-build -- \
 		$(opt_reproduce) \
 		--enable-threads --disable-static \
@@ -91,7 +102,7 @@
     opt_optimize_small += --disable-assembler
 endif
 
-ifneq (,$(findstring n,$(MAKEFLAGS)))
+ifneq (,$(findstring n,$(firstword -$(MAKEFLAGS))))
     opt_no_act = --no-act
 endif

=== debian/watch ===
version=4
opts=dversionmangle=s/\+\d{8}$//,pgpsigurlmangle=s/$/.sig/ \
https://tukaani.org/xz/		\
https://github.com/tukaani-project/xz/releases/download/v[^/]+/xz-(5\.8\.[\d\.]*(?:beta|alpha)?)\.tar\.xz

## xz-utils 5.8.2

=== debian/changelog ===
xz-utils (5.8.2-2) unstable; urgency=medium

  * Configure gbp.conf correctly following DEP-14 and using pristine-tar
  * Add upstream metadata file
  * Enable Salsa CI using default template
  * Add myself as uploader as I intend to help maintain this package
  * Revert "Add 5.8 symbols." as it didn't actually add any
  * Set DPKG_GENSYMBOLS_CHECK_LEVEL to '4' to ensure symbols are checked
  * Add missing symbols for XZ 5.8
  * Sort the symbols file
  * Apply `wrap-and-sort -vast` to all files for easier maintenance
  * Drop redundant `Rules-Requires-Root: no`
  * Drop redundant `Priority: optional`
  * Bump Debian Policy version
  * Update Debian copyright for 2026
  * Add short license summary to header stanza to fix Lintian warning
  * Update FSF address references in copyright file
  * Remove license files from Files section in debian/copyright
  * Update watch file to version 5
  * Simplify watch file and allow it to detect any new upstream release
  * Fix misc issues in XZ man page (Closes: #1094436)

 -- Otto Kekäläinen <otto@debian.org>  Fri, 16 Jan 2026 07:13:14 +0000

xz-utils (5.8.2-1) unstable; urgency=medium

  * Import 5.8.2
    - Add a workaround for Red Hat Enterprise Linux 9 kernel bug
     (Closes: #1121085).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Fri, 26 Dec 2025 19:52:09 +0100

=== debian/control ===
--- 
+++ 
@@ -1,26 +1,39 @@
 Source: xz-utils
 Section: utils
-Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Sebastian Andrzej Siewior <sebastian@breakpoint.cc>
-Uploaders: Jonathan Nieder <jrnieder@gmail.com>
-Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.2),
- autoconf (>= 2.64~), automake, libtool (>= 2.2),
- gettext, autopoint | gettext (<< 0.18-1), autopoint | cvs, po4a
-Build-Depends-Indep: doxygen, graphviz
-Build-Conflicts: automake1.4
-Standards-Version: 4.7.2
+Maintainer: Sebastian Andrzej Siewior <sebastian@breakpoint.cc>
+Uploaders:
+ Jonathan Nieder <jrnieder@gmail.com>,
+ Otto Kekäläinen <otto@debian.org>,
+Build-Depends:
+ debhelper-compat (= 13),
+ dpkg-dev (>= 1.16.2),
+ autoconf (>= 2.64~),
+ automake,
+ autopoint | cvs,
+ autopoint | gettext (<< 0.18-1),
+ gettext,
+ libtool (>= 2.2),
+ po4a,
+Build-Depends-Indep:
+ doxygen,
+ graphviz,
+Build-Conflicts:
+ automake1.4,
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/debian/xz-utils
 Vcs-Git: https://salsa.debian.org/debian/xz-utils.git
 Homepage: https://tukaani.org/xz/
-Rules-Requires-Root: no
 
 Package: liblzma5
 Section: libs
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Pre-Depends: ${misc:Pre-Depends}
-Breaks: liblzma2 (<< 5.1.1alpha+20110809-3~)
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
+Pre-Depends:
+ ${misc:Pre-Depends},
+Breaks:
+ liblzma2 (<< 5.1.1alpha+20110809-3~),
 Multi-Arch: same
 Description: XZ-format compression library
  XZ is the successor to the Lempel-Ziv/Markov-chain Algorithm
@@ -35,19 +48,33 @@
 Package-Type: udeb
 Section: debian-installer
 Architecture: any
-Depends: ${shlibs:Depends}
+Depends:
+ ${shlibs:Depends},
 Description: XZ-format compression library
  This liblzma package is only for use in the installation system.
 
 Package: xz-utils
 Priority: standard
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Multi-Arch: foreign
-Conflicts: lzma (<< 9.22-1), xz-lzma
-Breaks: lzip (<< 1.8~rc2), manpages-de (<< 4.17.0-2~bpo11+1), manpages-fr (<< 4.17.0-2~bpo11+1), pristine-tar (<< 1.50+nmu1)
-Replaces: lzip (<< 1.8~rc2), xz-lzma, manpages-de (<< 4.17.0-2~bpo11+1), manpages-fr (<< 4.17.0-2~bpo11+1)
-Provides: lzma
+Conflicts:
+ lzma (<< 9.22-1),
+ xz-lzma,
+Breaks:
+ lzip (<< 1.8~rc2),
+ manpages-de (<< 4.17.0-2~bpo11+1),
+ manpages-fr (<< 4.17.0-2~bpo11+1),
+ pristine-tar (<< 1.50+nmu1),
+Replaces:
+ lzip (<< 1.8~rc2),
+ manpages-de (<< 4.17.0-2~bpo11+1),
+ manpages-fr (<< 4.17.0-2~bpo11+1),
+ xz-lzma,
+Provides:
+ lzma,
 Description: XZ-format compression utilities
  XZ is the successor to the Lempel-Ziv/Markov-chain Algorithm
  compression format, which provides memory-hungry but powerful
@@ -70,11 +97,16 @@
 
 Package: xzdec
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Multi-Arch: foreign
-Suggests: xz-utils
-Breaks: xz-lzma (<< 4.999.9beta+20091004-1)
-Replaces: xz-lzma (<< 4.999.9beta+20091004-1)
+Suggests:
+ xz-utils,
+Breaks:
+ xz-lzma (<< 4.999.9beta+20091004-1),
+Replaces:
+ xz-lzma (<< 4.999.9beta+20091004-1),
 Description: XZ-format compression utilities - tiny decompressors
  XZ is the successor to the Lempel-Ziv/Markov-chain Algorithm
  compression format, which provides memory-hungry but powerful
@@ -99,8 +131,11 @@
 Section: libdevel
 Multi-Arch: same
 Architecture: any
-Depends: liblzma5 (= ${binary:Version}), ${misc:Depends}
-Suggests: liblzma-doc
+Depends:
+ liblzma5 (= ${binary:Version}),
+ ${misc:Depends},
+Suggests:
+ liblzma-doc,
 Description: XZ-format compression library - development files
  XZ is the successor to the Lempel-Ziv/Markov-chain Algorithm
  compression format, which provides memory-hungry but powerful
@@ -115,8 +150,10 @@
 Section: doc
 Multi-Arch: foreign
 Architecture: all
-Depends: ${misc:Depends}
-Suggests: liblzma-dev
+Depends:
+ ${misc:Depends},
+Suggests:
+ liblzma-dev,
 Description: XZ-format compression library - API documentation
  This package contains a reference manual for the liblzma data
  compression library, in Doxygen-generated HTML files. The purpose

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,12 @@
 #!/usr/bin/make -f
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
+# Only do a strict symbol checking on Linux
+# https://manpages.debian.org/testing/dpkg-dev/dpkg-gensymbols.1.en.html
+# Level 4: Fails if some libraries have been introduced.
+ifneq (,$(filter linux,$(DEB_HOST_ARCH_OS)))
+    export DPKG_GENSYMBOLS_CHECK_LEVEL = 4
+endif
 
 %:
 	dh $@ $(opt_no_act)

=== debian/tests/control ===
Tests:
 testsuite,
Depends:
 debhelper-compat (= 13),
 autoconf (>= 2.64~),
 automake,
 gettext,
 libtool (>= 2.2),
 @,
Restrictions:
 allow-stderr,
 rw-build-tree,

=== debian/watch ===
Version: 5

Source: https://tukaani.org/xz/
Matching-Pattern: https://github.com/tukaani-project/xz/releases/download/v[^/]+/xz-@ANY_VERSION@\.tar\.(?:xz|bz2|gz)
Dversion-Mangle: s/\+\d{8}$//
Pgp-Sig-Url-Mangle: s/$/.sig/
